;########################################################
;#                                                      #
;#                     PPATCH                           #
;#                                                      #
;########################################################
;# H89PIP PATCH FOR HEATH CP/M V2.2                     #
;#                                                      #
;# THIS PROGRAM RUNS AFTER A COLD BOOT AND INSTALLS THE #
;# THE CODE NEEDED TO OPERATE MOST ANY PRINTER VIA AN   #
;# H89PIP PARALLEL INTERFACE PORT CARD.                 #
;#                                                      #
;# USE THE CONFIGUR PROGRAM TO SET UP THE FOLLOWING     #
;# CONDITIONS:                                          #
;#                                                      #
;# 1. NO DEVICE USES H89PIP PORT ADDRESS (320Q).        #
;# 2. PPATCH PROGRAM RUNS AFTER COLD BOOT.              #
;# 3. LST:=LPT:
;#                                                      #
;########################################################
;
PORT    EQU 320Q        ;BASE PORT ADDRESS
;
JRNZ    EQU 20H         ;Z80 OPCODE JR NZ,
JRZ     EQU 28H         ;Z80 OPCODE JR Z,
;
        ORG 100H
START:  DI              ;PROTECT AGAINST INTERRUPTS
        MVI A,81H       ;INIT THE 8255
        OUT PORT+3
        MVI A,70H       ;SET THE PORT "C" LEVELS
        OUT PORT+2
        EI              ;ENABLE INTERRUPTS

        MVI C,9         ;ANNOUNCE OUR ACTIVITY
        LXI D,TEXT
        CALL 5

        LHLD 1          ;ACCESS BIOS JUMP TABLE
        LXI D,43
        DAD D
        CALL GETADR     ;GET ADDRESS OF "LISTST" CODE

        LXI D,12        ;ACCESS "LISTST" BRANCH TABLE
        DAD D
        CALL GETADR     ;GET ADDRESS OF "LPTOS" CODE
        SHLD LPTOUT+1   ;FIX NEW "LPTOUT" CODE

        LXI D,LPTOS     ;INSTALL NEW CODE
        MVI B,10
        CALL MOVE

        LHLD 1          ;ACCESS BIOS JUMP TABLE AGAIN
        LXI D,13
        DAD D
        CALL GETADR     ;GET ADDRESS OF "LIST" CODE

        LXI D,12        ;ACCESS "LIST" BRANCH TABLE
        DAD D
        CALL GETADR

        LXI D,LPTOUT    ;INSTALL NEW CODE
        MVI B,20
        CALL MOVE
        RET
;
;
;GETADR -
;  GET ADDRESS VIA HL INTO HL.
;
GETADR: MOV A,M
        INX H
        MOV H,M
        MOV L,A
        RET
;
;
;MOVE -
;  MOVE B BYTES FROM DE TO HL.
;
MOVE:   LDAX D
        MOV M,A
        INX H
        INX D
        DCR B
        JNZ MOVE
        RET
;
;
TEXT:   DB 'INSTALLING H89PIP LPT PRINTER DRIVER'
        DB '$'
;
;
;LPTOS -
;  READ AND RETURN PRINTER STATUS.  STANDARD CP/M.
;
LPTOS:  IN PORT+2       ;READ STATUS
        ANI 04H         ;ISOLATE BUSY BIT
        DB JRNZ,2       ;RELATIVE BRANCH
        DCR A           ;RETURN 0FFH IF READY
        RET
NOTRDY: XRA A           ;RETURN ZERO IF NOT READY
        RET
;
;
;LPTOUT -
;  OUTPUT REGISTER C TO PRINTER.
;
LPTOUT: CALL LPTOS      ;READ STATUS
        ORA A           ;SET FLAGS
        DB JRZ,0FAH     ;WAIT FOR STATUS
        MOV A,C         ;GET BYTE
        OUT PORT+1      ;OUTPUT BYTE
        DI              ;NO INTERRUPTS
        MVI A,60H       ;DO A STROBE PULSE
        OUT PORT+2
        MVI A,70H
        OUT PORT+2
        EI              ;ENABLE INTERRUPTS
        RET
;
        END START
88888999999%959=9I9N9W9^9